# coding:utf-8
import os
import re

import threading
import os.path
import wx
import sys, locale
import wx.adv
import pyperclip
import time
import webbrowser
import urllib.request, urllib.parse, urllib.error
import urllib.request, urllib.error, urllib.parse
import random
import json

import configparser
import requests
from urllib.parse import urlparse



def url_fix(input_url ):
    input_url = re.sub(r'https?://www.flickr.com/photos/', '', input_url)
    input_url = re.sub(r'https?://www.flickr.com/photos', '', input_url)
    input_url = re.sub(r'https?://www.flickr.com/search/\?text=', '', input_url)
    input_url = re.sub(r'https?://www.flickr.com/photos/tags/', '', input_url)
    input_url = re.sub(r'https?://www.flickr.com/photos/tags', '', input_url)

    input_url = re.sub(r'https?://', '', input_url)
    input_url = input_url.replace('/', '')

    return input_url


def kinshi_replace(filename):
    filename = filename.replace('/', '')
    filename = filename.replace('?', '')
    filename = filename.replace('!', '')
    filename = filename.replace(':', '')
    filename = filename.replace('\\', '')
    filename = filename.replace('<', '')
    filename = filename.replace('>', '')
    filename = filename.replace('*', '')
    filename = filename.replace('"', '')
    filename = filename.replace(' ', '_')

    return filename




def wait_func(gui):
    global wait_float
    if wait_float == 0:
        return
    gui.mes("wait開始します。",1)
    try:
        time.sleep(wait_float)
    except Exception as e:
        gui.error_mes(e)




def sqlite_hash_db_del(gui):
    global hash_sqlite_auto_del
    if hash_sqlite_auto_del==1:
        try:
            connector = sqlite3.connect("hash.db")
            gui.mes( "hash.dbの全レコードを削除します。",1)
            sql = "DELETE FROM table1;"

            connector.execute(sql)

            connector.commit()

            connector.close()
        except Exception as e:
            gui.error_mes(e)
def sqlite_hash_add(hash,hozon_path,gui):

    try:
        connector = sqlite3.connect("hash.db")

        sql_select = "select * from table1 where hash='" + hash + "'"

        db_hash=""
        for row in connector.execute(sql_select):
            db_hash=str(row)

            db_hash = db_hash.replace("(u'", "")
            db_hash = db_hash.replace("',)", "")

            if hash==db_hash:
                exist_bool = os.path.exists(hozon_path)
                if exist_bool == True:
                    gui.mes( hozon_path+":dbに重複ハッシュがあるので削除します。。",1)
                    os.remove(hozon_path)

        if len(db_hash)==0:

            sql = "INSERT INTO table1 VALUES('"+hash+"')"

            connector.execute(sql)

            connector.commit()

            connector.close()
    except Exception as e:
        gui.error_mes(e)

def hash_get(hozon_path,gui):
    md5 = hashlib.md5()
    try:
        with open(hozon_path, 'rb') as f:
            for chunk in iter(lambda: f.read(2048 * md5.block_size), b''):
                md5.update(chunk)
        checksum = md5.hexdigest()
    except Exception as e:
        gui.error_mes(e)
    return checksum

def down_video(video_url,id,fol_st,gui):
    global local_folder
    hozon_path = local_folder +fol_st+"/"+ id + ".mp4"

    exist_bool = os.path.exists(hozon_path)
    if exist_bool == True:
        gui.mes( hozon_path + "重複をスルーします。",1)
    if exist_bool == False:
        gui.mes( video_url + "をダウンロードします。",1)
        if wget_flag==1:
            wget_video_down(video_url,hozon_path )
            return
        urlopen_down(video_url, hozon_path,gui)

def urlopen_down(down_url,hozon_path,gui):
    global hash_sqlite
    try:
        request = requests.get(down_url, timeout=35, stream=True)

        # Open the output file and make sure we write in binary mode
        with open(hozon_path, 'wb') as fh:
            # Walk through the request response in chunks of 1024 * 1024 bytes, so 1MiB
            for chunk in request.iter_content(1024 * 1024):
                # Write the chunk to the file
                fh.write(chunk)

    except Exception as e:
        gui.error_mes(e)
    if hash_sqlite==1:
        hash_st=hash_get(hozon_path,gui)

        sqlite_hash_add(hash_st,hozon_path,gui)

def down_main(img_url,title, tags, description, ownername, datetaken,fol_st,gui):
    global local_folder

    sp = img_url.split("/")
    file_name = sp[len(sp) - 1]
    file_name=kinshi_replace(file_name)
    hozon_path=local_folder+fol_st+"/"+file_name
    exist_bool = os.path.exists(hozon_path)
    if exist_bool == True:
        gui.mes( hozon_path + "重複をスルーします。",1)
    if exist_bool == False:
        gui.mes(img_url + "をダウンロードします。", 1)

        if wget_flag==1:
            wget_down(img_url,hozon_path,title, tags, description, ownername, datetaken,fol_st)

        if wget_flag == 0:
             urlopen_down(img_url, hozon_path,gui)

        exist_bool = os.path.exists(hozon_path)
        if exist_bool == True:
            fsize = os.path.getsize(hozon_path)
            if fsize <= 4000:
                try:
                    gui.mes( hozon_path + ":ゴミファイルを削除します。",1)
                    os.remove(hozon_path)
                except Exception as e:
                    gui.error_mes(e)
        exist_bool = os.path.exists(hozon_path)
        if exist_bool == True:
            after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)

def time_fix_sub(hozon_path,datetaken,gui):
    global time_fix
    if time_fix==1:
        if len(datetaken)!=0:
            try:
                createdate_tap = time.strptime(datetaken, '%Y-%m-%d %H:%M:%S')
                updatedate_tap = time.strptime(datetaken, '%Y-%m-%d %H:%M:%S')

                times = (time.mktime(createdate_tap), time.mktime(updatedate_tap))
                os.utime(hozon_path, times)
            except Exception as e:
                gui.error_mes(e)

def exif_write(img_url,hozon_path,title,tags,description,ownername,gui ):
    global _exif
    if _exif==1:
        if re.compile("(jpg|JPG)").search(img_url):

            exist_bool = os.path.exists("exif_write.exe")
            if exist_bool == False:
                gui.mes( ":exif_write.exeがありません。",1)
                return
            exist_bool = os.path.exists(hozon_path)
            if exist_bool == True:
                try:
                    #subprocess.call([notepad.encode(sys.getfilesystemencoding())])
                    subprocess.call(["exif_write.exe", "" + hozon_path.encode(sys.getfilesystemencoding()) + "", "" + title.encode(sys.getfilesystemencoding()) + "", "" + tags.encode(sys.getfilesystemencoding()) + "", "" + description.encode(sys.getfilesystemencoding()) + "",
                        "" + ownername.encode(sys.getfilesystemencoding()) + ""])
                except Exception as e:
                    gui.error_mes(e)
            if exist_bool == False:
                gui.mes( hozon_path+":exif_write.exeがありません。",1)
def wget_video_down(down_url,hozon_path,gui):
    global hash_sqlite
    try:


        proc = subprocess.call('wget -nc --no-check-certificate --read-timeout=25 --connect-timeout=25 --read-timeout=120 --tries 1 "'+ down_url+'" -O "'+hozon_path+'"'
                           ,shell=True)
    except Exception as e:
        gui.error_mes(e)
    exist_bool = os.path.exists(hozon_path)
    if exist_bool == True:
        fsize = os.path.getsize(hozon_path)
        if fsize <= 4000:
            try:
                gui.mes( hozon_path + ":ゴミファイルを削除します。",1)
                os.remove(hozon_path)
            except Exception as e:
                gui.error_mes(e)

    if hash_sqlite==1:
        hash_st=hash_get(hozon_path,gui)
        sqlite_hash_add(hash_st,hozon_path,gui)

def wget_down(down_url,hozon_path, title, tags, description, ownername, datetaken,fol_st,gui):
    try:

        proc = subprocess.call('wget -nc --no-check-certificate --tries 1 "' + down_url + '" -O "'+hozon_path+'"'
                               , shell=True)
    except Exception as e:
        gui.error_mes(e)
    exist_bool = os.path.exists(hozon_path)
    if exist_bool == True:
        fsize = os.path.getsize(hozon_path)
        if fsize <= 4000:
            try:
                gui.mes( hozon_path + ":ゴミファイルを削除します。",1)
                os.remove(hozon_path)
            except Exception as e:
                gui.error_mes(e)
    exist_bool = os.path.exists(hozon_path)
    if exist_bool == True:
        after_down(down_url, title, tags, description, ownername, datetaken,fol_st,gui)


def after_down(img_url,title,tags,description,ownername,datetaken,fol_st,gui ):
    sp = img_url.split("/")
    file_name = sp[len(sp) - 1]
    hozon_path = local_folder+fol_st+"/"+file_name
    exif_write(img_url, hozon_path, title, tags, description, ownername,gui)
    time_fix_sub(hozon_path,datetaken,gui)

def max_size_sub(i,title,tags,description,ownername,datetaken,fol_st,gui):

    if "url_o" in i:
        img_url = i['url_o']
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)

        return

    if "url_k" in i:
        img_url = i['url_k']
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        return

    if "url_h" in i:
        img_url = i['url_h']
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        return
    if "url_l" in i:
        img_url = i['url_l']
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        return

    if "url_c" in i:
        img_url = i['url_c']
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        return

    if "url_z" in i:
        img_url = i['url_z']
        img_url = img_url.replace("?zz=1", "")
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        return
    if "url_m" in i:
        img_url = i['url_m']
        down_main(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        after_down(img_url, title, tags, description, ownername, datetaken,fol_st,gui)
        return


def flicker_main_loop(text_st,fol_text,gui):

    global local_folder

    global start_page
    global main_loop

    global end_page
    global sort
    global api_st
    global orientation
    global max_size

    global error_stop_flag

    global _o
    global _b
    global _z
    global _h
    global _c
    global _k

    global _s
    global _n
    global _t
    global _q
    global _k
    global _sq
    global _normal

    global _license

    global _media
    global _style
    global _color
    global _exif



    while main_loop == True:
        error_stop_flag = False

        lat_st = ""
        lng_st = ""
        if gui.radio4.GetValue() == True:


            if yahoo_api_type == 0:

                category = "address"
                if yahoo_api_category == 1:
                    category = "landmark"

                main_url = "https://map.yahooapis.jp/geocode/cont/V1/contentsGeoCoder?appid=" + yahoo_api_key + "&query=" + text_st + "&category=" + category
            if yahoo_api_type == 1:
                main_url = "https://map.yahooapis.jp/geocode/V1/geoCoder?appid=" + yahoo_api_key + "&query=" + text_st

            gui.mes(main_url + "を取得します。",1)
            html=""
            try:
                st_read = urllib.request.urlopen(main_url)
                html = str(st_read.read(), 'utf-8')
                st_read.close()
            except Exception as e:
                gui.error_mes(e)

            try:
                reg = re.compile('<Coordinates>([\.0-9]+),')

                for reg_chu in reg.finditer(html):
                    lng_st = reg_chu.group(1)
                reg = re.compile(',([\.0-9]+)</Coordinates>')

                for reg_chu in reg.finditer(html):
                    lat_st = reg_chu.group(1)
            except Exception as e:
                gui.error_mes(e)
            gui.mes( "緯度(Lat)"+lat_st+ "経度(lng)"+lng_st, 1)

        count=0
        fol_st=""
        page_su_int=0
        if start_page!=1:
            page_su_int=start_page-1
        if make_folder==1:
            fol_st=fol_text

            fol_st=kinshi_replace(fol_st)


            dir_bool=os.path.exists(local_folder+fol_st)


            hozon=local_folder+fol_st
            if os.path.isdir(hozon)==False:
                try:

                   os.mkdir(hozon)
                except Exception as e:

                  gui.error_mes(e)

        page_su_st=""
        count_st=""
        sort_st = "&sort=date-posted-desc"
        if sort == 1:
            sort_st = "&sort=date-posted-asc"
        if sort == 2:
            sort_st = "&sort=date-taken-asc"
        if sort == 3:
            sort_st = "&sort=date-taken-desc"
        if sort == 4:
            sort_st = "&sort=interestingness-desc"
        if sort == 5:
            sort_st = "&sort=interestingness-asc"
        if sort == 6:
            sort_st = "&sort=relevance"
        media_st = ""
        if _media == 1:
            media_st = "&media=video"
        if _media == 2:
            media_st = "&media=photo"
        style_st = ""
        if _style == 1:
            style_st = "&styles=blackandwhite"
        if _style == 2:
            style_st = "&styles=pattern"
        if _style == 3:
            style_st = "&styles=minimalism"
        if _style == 4:
            style_st = "&styles=depthoffield"
        color_st = ""
        if _color == 1:
            color_st = "&color_codes=0"
        if _color == 2:
            color_st = "&color_codes=1"
        if _color == 3:
            color_st = "&color_codes=2"
        if _color == 4:
            color_st = "&color_codes=3"
        if _color == 5:
            color_st = "&color_codes=4"
        if _color == 6:
            color_st = "&color_codes=5"
        if _color == 7:
            color_st = "&color_codes=6"
        if _color == 8:
            color_st = "&color_codes=7"
        if _color == 9:
            color_st = "&color_codes=8"
        if _color == 10:
            color_st = "&color_codes=9"
        if _color == 11:
            color_st = "&color_codes=a"
        if _color == 12:
            color_st = "&color_codes=b"
        if _color == 13:
            color_st = "&color_codes=c"
        if _color == 14:
            color_st = "&color_codes=d"
        if _color == 15:
            color_st = "&color_codes=e"
        orientation_st = ""
        if orientation == 1:
            orientation_st = "&orientation=landscape"
        if orientation == 2:
            orientation_st = "&orientation=portrait"
        if orientation == 3:
            orientation_st = "&orientation=square"
        # if orientation==4:
        #     orientation_st = "&orientation=panorama"

        license_st = ""
        if _license == 1:
            # All creative commons
            license_st = "&license=2,3,4,5,6,9"
        if _license == 2:
            # Commercial use allowed
            license_st = "&license=4,5,6,9,10"
        if _license == 3:
            # Modifications allowed
            license_st = "&license=1,2,9,10"
        if _license == 4:
            # Commercial use & mods allowed
            license_st = "&license=4,5,9,10"
        if _license == 5:
            # No known copyright restrictions
            license_st = "&license=7,9,10"
        if _license == 6:
            # U.S. Government works
            license_st = "&license=8"

        while 0==0:
            start = time.time()
            page_su_int=page_su_int+1
            page_su_st=str(page_su_int)
            gui.mes(page_su_st, 3)
            gui.mes( page_su_st+"ページ目",1)

            main_url=""


            if gui.radio1.GetValue() == True:
                main_url = "https://www.flickr.com/services/rest/?jsoncallback=foo&format=json&method=flickr.photos.search&api_key=" + api_st + "&user_id=" + text_st + sort_st +media_st+style_st+color_st+ orientation_st+license_st+ "&per_page=500&extras=description,date_upload,date_taken,owner_name,tags,url_sq,url_t,url_s,url_q,url_m,url_n,url_z,url_c,url_l,url_o,url_h,url_k,media&page=" + page_su_st

            if gui.radio2.GetValue() == True:
                main_url = "https://www.flickr.com/services/rest/?jsoncallback=foo&format=json&method=flickr.photos.search&api_key=" + api_st + "&text=" + text_st + sort_st +media_st+style_st+ color_st+ orientation_st+ license_st+"&per_page=500&extras=description,date_upload,date_taken,owner_name,tags,url_sq,url_t,url_s,url_q,url_m,url_n,url_z,url_c,url_l,url_o,url_h,url_k,media&page=" + page_su_st

            if gui.radio3.GetValue() == True:
                main_url = "https://www.flickr.com/services/rest/?jsoncallback=foo&format=json&method=flickr.photos.search&api_key=" + api_st + "&tags=" + text_st + sort_st + media_st + style_st + color_st + orientation_st + license_st + "&per_page=500&extras=description,date_upload,date_taken,owner_name,tags,url_sq,url_t,url_s,url_q,url_m,url_n,url_z,url_c,url_l,url_o,url_h,url_k,media&page=" + page_su_st
            if gui.radio4.GetValue() == True:
                sort_st = "&sort=date-posted-desc"
                main_url = "https://www.flickr.com/services/rest/?jsoncallback=foo&format=json&method=flickr.photos.search&api_key=" + api_st + sort_st + media_st + style_st + color_st + orientation_st + license_st + "&lat=" + lat_st + "&lon=" + lng_st + "&per_page=500&extras=description,date_upload,date_taken,owner_name,tags,url_sq,url_t,url_s,url_q,url_m,url_n,url_z,url_c,url_l,url_o,url_h,url_k,media&page=" + page_su_st

            gui.mes( main_url+"を取得します。",1)
            html=""
            try:
                st_read = urllib.request.urlopen(main_url)
                html = str(st_read .read(),'utf-8')
                st_read.close()
            except Exception as e:
                error_stop_flag=True
                gui.error_mes(e)
            if main_loop == False:
                break

            html = html.replace("foo(", "")
            html = re.sub(r'\)$', '', html)

            url_list=[]


            farm = 0;
            server = 0
            id = 0
            datetaken=""
            secret = 0
            total =0
            tags=""
            title=""
            count2=0
            count2_st = ""
            description=""
            owner=""
            ownername = ""
            media=""
            try:
                total=int(json.loads(html)['photos']['total'])
            except Exception as e:
                gui.error_mes(e)
            total_st = str(total)

            if main_loop == False:
                break

            gui.mes( "画像総数"+total_st,1)
            count_st=str(count)
            for i in json.loads(html)['photos']['photo']:
                if main_loop == False:
                    break
                count2=count2+1
            count2_st=str(count2)
            gui.mes( "取得済み画像数" + count_st,1)

            gui.mes( "取得画像数" +count2_st,1)
            for i in json.loads(html)['photos']['photo']:
                try:
                    if "id" in i:
                        id=str(i['id'])
                    if "media" in i:
                        media=str(i['media']);
                        if media=="video":

                            video_url="https://www.flickr.com/video_download.gne?id="+id

                            down_video(video_url,id,fol_st,gui)

                    if main_loop == False:
                        break

                    if "farm" in i:
                        farm=str(i['farm']);
                    if max_size ==1:
                        max_size_sub(i,title, tags, description, ownername, datetaken,fol_st,gui)

                    if max_size!=1:
                        if _z==1:
                            if "url_z" in i:
                                img_url = i['url_z']
                                img_url = img_url.replace("?zz=1", "")
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                        if main_loop == False:
                            break
                        if _c == 1:
                            if "url_c" in i:
                                img_url = i['url_c']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                        if main_loop == False:
                            break
                        if _o == 1:
                            if "url_o" in i:
                                img_url = i['url_o']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                        if main_loop == False:
                            break
                        if _b == 1:
                            if "url_l" in i:
                                img_url = i['url_l']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)

                        if _t == 1:
                            if "url_t" in i:
                                img_url = i['url_t']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)

                        if _s == 1:
                            if "url_s" in i:
                                img_url = i['url_s']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)


                        if _n == 1:
                            if "url_n" in i:
                                img_url = i['url_n']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)

                        if _q == 1:
                            if "url_q" in i:
                                img_url = i['url_q']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)

                        if _sq == 1:
                            if "url_sq" in i:
                                img_url = i['url_sq']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                        if main_loop == False:
                            break
                        if _h == 1:
                            if "url_h" in i:
                                img_url = i['url_h']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                        if main_loop == False:
                            break
                        if _k == 1:
                            if "url_k" in i:
                                img_url = i['url_k']
                                down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                                after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)

                    if "server" in i:
                        server=i['server']
                    if "id" in i:
                        id=i['id']
                    if "secret" in i:
                        secret = i['secret']
                    if "owner" in i:
                        owner = i['owner']
                    if "tags" in i:
                        tags = i['tags']
                        tags = tags.replace(" ", ";")
                    if "ownername" in i:
                        ownername= i['ownername']
                    if "title" in i:
                        title = i['title']
                    if "description" in i:
                        description= i['description']['_content']
                    if "datetaken" in i:
                        datetaken = i['datetaken']

                    img_url = "https://farm" + str(farm) + ".staticflickr.com/" + str(server) + "/" + str(id) + "_" + str(
                    secret) + ".jpg"

                except Exception as e:
                    gui.error_mes(e)

                if max_size != 1:
                    if _normal == 1:
                        down_main(img_url, title, tags, description, ownername, datetaken, fol_st,gui)
                        after_down(img_url, title, tags, description, ownername, datetaken, fol_st,gui)

                count=count+1
                if main_loop == False:
                    break
            if main_loop == False:
                break
            if count2==0:
                return;
            if total<=count:
                return;
            if count2<20:
                return;


            if end_page!=0:
                if end_page<=page_su_int:
                    return;
            elapsed_time=0
            try:
                elapsed_time = time.time() - start
            except Exception as e:
                gui.error_mes(e)

            if  elapsed_time<5:
                gui.mes( "api連続取得防止の為にwait開始",1)
                wait_func(gui)

        # メッセージクリア
        if mes_clear == 1:
            gui.mes("", 2)
        break






def setting(gui):
    global local_folder
    global log
    global wait_float
    global mes_clear
    global start_page
    global main_loop
    global end_flag
    global queue_lists
    global open_url
    global br
    global enc_key
    global make_folder
    global start_id

    global end_id
    global end_page
    global sort
    global api_st
    global orientation
    global max_size
    global wget_flag
    global auto_start
    global loop_wait
    global batch_loop
    global error_stop_flag
    global hometimeline_wait
    global hash_sqlite
    global hash_sqlite_auto_del
    global yahoo_api_key
    global yahoo_api_type
    global yahoo_api_category
    global _o
    global _b
    global _z
    global _h
    global _c
    global _k

    global _s
    global _n
    global _t
    global _q
    global _k
    global _sq
    global _normal

    global _license

    global _media
    global _style
    global _color
    global _exif
    global time_fix
    global _radio_check

    queue_lists=[]
    enc_key = ""
    end_flag = True
    main_loop = True
    local_folder = "./"

    start_page = 1

    make_folder = 0
    start_id = 0

    end_id = 0
    _o = 0
    _b = 0
    _z = 0
    _h = 0
    _c = 0
    _k = 0

    _s = 0
    _n = 0
    _t = 0
    _q = 0
    _k = 0
    _sq = 0
    _normal = 0

    _license = 0

    _media = 0
    _style = 0
    _color = 0
    _exif = 0

    start_page = 1

    make_folder = 0
    end_page = 0
    sort = 0
    api_st = ""
    orientation = 0
    max_size = 0
    wget_flag = 0
    auto_start = 0
    loop_wait = 0
    batch_loop = 0
    error_stop_flag = False
    hometimeline_wait = 100
    hash_sqlite = 0
    hash_sqlite_auto_del = 0
    yahoo_api_key = ""
    yahoo_api_type = 0
    yahoo_api_category = 0
    _radio_check=0
    mes_clear=0
    exist_bool = os.path.exists("./setting.ini")

    if exist_bool == True:
        inifile = configparser.ConfigParser()
        inifile.read("./setting.ini")
        try:
            local_folder = str(inifile.get("config", "down_folder"))

            time_fix = int(inifile.get("config", "time_fix"))
            api_st = (inifile.get("config", "api"))
            _b = int((inifile.get("config", "b")))
            _z = int((inifile.get("config", "z")))
            _h = int((inifile.get("config", "h")))
            _c = int((inifile.get("config", "c")))
            _k = int((inifile.get("config", "k")))

            _o = int((inifile.get("config", "o")))
            _q = int((inifile.get("config", "q")))
            _t = int((inifile.get("config", "t")))
            _sq = int((inifile.get("config", "sq")))
            _n = int((inifile.get("config", "n")))
            _normal = int((inifile.get("config", "m")))
            _exif = int((inifile.get("config", "exif")))
            sort = int((inifile.get("config", "sort")))
            _media = int((inifile.get("config", "media")))
            _style = int((inifile.get("config", "style")))
            _color = int((inifile.get("config", "color")))
            orientation = int((inifile.get("config", "orientation")))
            _license = int((inifile.get("config", "license")))
            max_size = int((inifile.get("config", "max_size")))
            wget_flag = int((inifile.get("config", "wget")))
            start_page = int((inifile.get("config", "start_page")))
            end_page = int((inifile.get("config", "end_page")))
            make_folder = int((inifile.get("config", "make_folder")))
            auto_start = int((inifile.get("config", "auto_start")))
            loop_wait = int(inifile.get("config", "loop_wait"))
            batch_loop = int(inifile.get("config", "batch_loop"))

            hash_sqlite = int(inifile.get("config", "hash_sqlite"))
            hash_sqlite_auto_del = int(inifile.get("config", "hash_sqlite_auto_del"))
            yahoo_api_key = inifile.get("config", "yahoo_api_key")
            yahoo_api_type = int(inifile.get("config", "yahoo_api_type"))
            yahoo_api_category = int(inifile.get("config", "yahoo_api_category"))
            _radio_check = int(inifile.get("config", "radio_check"))
            mes_clear = int(inifile.get("config", "mes_clear"))


        except Exception as e:
            gui.error_mes(e)

    if exist_bool == False:
        local_folder = "./";





def write_text_func(text,gui):
    try:
        f = open('log.txt', 'a')

        f.write(text + '\n')

        f.close()

    except Exception as e:
        gui.error_mes(e)

def main_sub(enc_tag, dec_tag, gui):

    global main_loop
    global end_flag
    global queue_lists
    sqlite_hash_db_del(gui)
    while main_loop == True:
        flicker_main_loop(enc_tag, dec_tag, gui)
        #main_func(enc_tag, dec_tag, gui)
        if len(queue_lists) > 0:
            try:
                gui.mes(str(len(queue_lists)) + "個のキューを処理します。。",1)
            except Exception as e:
                gui.error_mes(e)
        break
    while main_loop == True:
        if main_loop == False:
            break
        if len(queue_lists) == 0:
            break

        count = 0
        for i in queue_lists:
            if main_loop == False:
                break
            count = count + 1
              #キュー削除
            try:
                gui.mes(str(count) + "個目のキューを処理します。。", 1)

                queue_lists.remove(i)

                enc_tag = urllib.parse.quote(i.encode("utf-8"))
            except Exception as e:
                gui.error_mes(e)

            flicker_main_loop(enc_tag, i, gui)
    queue_lists = []
    gui.mes("終わりました。",1)

    end_flag = True;



class MyURLDropTarget(wx.PyDropTarget):


    def __init__(self, window):

        wx.DropTarget.__init__(self)
        self.window = window

        self.data = wx.URLDataObject();
        self.SetDataObject(self.data)


    def OnDragOver(self, x, y, d):
        return wx.DragLink


    def OnData(self, x, y, d):



        if not self.GetData():
            return wx.DragNone


        global main_loop
        global end_flag
        global queue_lists
        select=1
        if self.window.radio2.GetValue() == True:
            select = 2
        if self.window.radio3.GetValue() == True:
            select = 3
        if self.window.radio4.GetValue() == True:
            select = 4
        input_url = self.data.GetURL()

        input_url = str(input_url)
        input_url = str(input_url)
        tag = "";
        enc_tag = "";
        if end_flag == True:
            main_loop = True

            end_flag = False
            url_check = None

            if self.window.radio2.GetValue() == True or self.window.radio3.GetValue() == True:
                try:
                    reg = re.compile("https?://[\w/:%#\$&\?\(\)~\.=\+\-]+")
                    for reg_chu in reg.finditer(input_url):
                        url_check = reg_chu.group(0)
                except Exception as e:
                    self.window.error_mes(e)
                if url_check is not None:

                    try:
                        tag = urllib.parse.unquote_plus(input_url)
                        tag = tag.decode("utf-8")

                        enc_tag = input_url

                    except Exception as e:
                        self.window.error_mes(e)
                if url_check is None:

                    try:
                        tag = input_url
                        enc_tag = urllib.parse.quote(input_url.encode("utf-8"))
                    except Exception as e:
                        self.window.error_mes(e)

                enc_tag = url_fix(enc_tag)
                tag = url_fix(tag)
            if self.window.radio1.GetValue() == True:
                input_url = url_fix(input_url)
                enc_tag = input_url
                tag = input_url

            self.window.mes(input_url + "をダウンロードします。", 1)

            thread1 = threading.Thread(target=main_sub, args=(enc_tag, tag, self.window,))
            thread1.start()

        else:
            #
            self.window.mes(tag + "をキューに追加します。",1)

            queue_lists.append(tag)
        return d


class GUI_class():
    def __init__(self):
        setting(self)
        global _radio_check



        self.frame = wx.Frame(None, -1, "textbox", size=(500, 400))


        self.frame.SetTitle('flickrダウンローダGUI')
        panel_ui = wx.Panel(self.frame, -1, pos=(0, 0), size=(500, 400))
        #url入力
        self.text1 = wx.TextCtrl(panel_ui, -1, pos=(10, 30), size=(300, 30))

        dt = MyURLDropTarget(self)
        self.frame.SetDropTarget(dt)

        btn = wx.Button(panel_ui, -1, '開始', pos=(10, 70), size=(60, 30))
        btn.Bind(wx.EVT_BUTTON, self.Clicked)

        btn2 = wx.Button(panel_ui, -1, '停止', pos=(80, 70), size=(60, 30))
        btn2.Bind(wx.EVT_BUTTON, self.end)
        btn3 = wx.Button(panel_ui, -1, '閉じる', pos=(150, 70), size=(60, 30))
        btn3.Bind(wx.EVT_BUTTON, self.close)
        btn4 = wx.Button(panel_ui, -1, 'ver', pos=(220, 70), size=(60, 30))
        btn4.Bind(wx.EVT_BUTTON, self.mes_func)
        btn5 = wx.Button(panel_ui, -1, '貼る', pos=(290, 70), size=(60, 30))
        btn5.Bind(wx.EVT_BUTTON, self.paste)


        self.radio1 = wx.RadioButton(panel_ui, -1, 'ユーザー画像', pos=(140, 120), style=wx.RB_GROUP, size=(90, 30))
        self.radio2 = wx.RadioButton(panel_ui, -1, '検索', pos=(240, 120), size=(40, 30))
        self.radio3 = wx.RadioButton(panel_ui, -1, 'タグ', pos=(290, 120), size=(40, 30))
        self.radio4 = wx.RadioButton(panel_ui, -1, '地名', pos=(340, 120), size=(40, 30))

        if _radio_check==1:
            self.radio2.SetValue(True)
        if _radio_check==2:
            self.radio3.SetValue(True)
        if _radio_check==3:
            self.radio4.SetValue(True)
        # メッセージ表示

        self.text2 = wx.TextCtrl(panel_ui, -1, pos=(10, 150), style=wx.TE_MULTILINE, size=(300, 200))

        #ページ
        self.text3 = wx.TextCtrl(panel_ui, -1, pos=(90, 110), size=(40, 30))

        self.frame.Show(True)



    def AfterRun(self, msg, select):
        # メインメッセージ画面
        if select == 1:
            print(msg)
            self.text2.AppendText(msg + "\n")
        # メインメッセージ画面
        if select == 2:
            self.text2.SetValue("")
        #ページ
        if select == 3:
            self.text3.SetValue(msg)

    def mes(self, text, select):
        # メインメッセージ画面
        if select == 1:
            wx.CallAfter(self.AfterRun, text, 1)
        # メインメッセージ画面クリア
        if select == 2:
            wx.CallAfter(self.AfterRun, text, 2)
        # ページ数
        if select == 3:
            wx.CallAfter(self.AfterRun, text, 3)

    def end(self, event):


        global main_loop
        main_loop = False

        end_flag = True


    def paste(self, event):

        global main_loop
        global end_flag
        global queue_lists
        enc_tag = "";
        select=1
        if self.radio2.GetValue() == True:
            select = 2
        if self.radio3.GetValue() == True:
            select = 3
        if self.radio4.GetValue() == True:
            select = 4
        input_url = pyperclip.paste()

        input_url = str(input_url)
        tag = "";
        enc_tag = "";
        if end_flag == True:
            main_loop = True

            end_flag = False
            url_check = None

            if self.radio2.GetValue() == True or self.radio3.GetValue() == True:
                try:
                    reg = re.compile("https?://[\w/:%#\$&\?\(\)~\.=\+\-]+")
                    for reg_chu in reg.finditer(input_url):
                        url_check = reg_chu.group(0)
                except Exception as e:
                    self.error_mes(e)
                if url_check is not None:

                    try:
                        tag = urllib.parse.unquote_plus(input_url)
                        tag = tag.decode("utf-8")

                        enc_tag = input_url

                    except Exception as e:
                        self.error_mes(e)
                if url_check is None:

                    try:
                        tag = input_url
                        enc_tag = urllib.parse.quote(input_url.encode("utf-8"))
                    except Exception as e:
                        self.error_mes(e)

                enc_tag = url_fix(enc_tag)
                tag = url_fix(tag)
            if self.radio1.GetValue() == True:
                input_url = url_fix(input_url)
                enc_tag = input_url
                tag = input_url
            if self.radio4.GetValue() == True:
                enc_tag = input_url
                try:
                    enc_tag = urllib.parse.quote(input_url.encode("utf-8"))
                except Exception as e:
                    self.error_mes(e)
            self.mes(input_url + "をダウンロードします。", 1)

            thread1 = threading.Thread(target=main_sub, args=(enc_tag, tag, self,))
            thread1.start()
        else:
            self.mes(tag + "をキューに入れます。",1)

            queue_lists.append(tag)

    def close(self, event):
        global main_loop
        main_loop = False
        wx.Exit()

    def Clicked(self, event):

        global main_loop
        global end_flag
        global queue_lists

        input_url = self.text1.GetValue()
        input_url=str(input_url)
        tag = "";
        enc_tag = "";


        if end_flag == True:
            main_loop = True

            end_flag = False
            url_check = None
            #検索かタグ
            if self.radio2.GetValue()==True or self.radio3.GetValue()==True:
                try:
                    reg = re.compile("https?://[\w/:%#\$&\?\(\)~\.=\+\-]+")
                    for reg_chu in reg.finditer(input_url):
                        url_check = reg_chu.group(0)
                except Exception as e:
                    self.error_mes(e)
                #urlならば
                if url_check is not None:

                    input_url = str(input_url)
                    input_url = url_fix(input_url)
                    print(input_url)
                    try:
                        tag = urllib.parse.unquote_plus(input_url)

                        enc_tag = input_url

                    except Exception as e:
                        self.error_mes(e)
                if url_check is None:

                    try:
                        enc_tag = urllib.parse.quote(input_url)

                        tag = input_url
                    except Exception as e:
                        self.error_mes(e)
            print("enc_tag"+enc_tag)
            print("tag"+tag)
            if self.radio1.GetValue() == True:
                input_url = url_fix(input_url)
                enc_tag = input_url
                tag = input_url
            if self.radio4.GetValue() == True:
                try:
                    enc_tag = urllib.parse.quote(input_url.encode("utf-8"))
                except Exception as e:
                    self.error_mes(e)
                tag = input_url


            self.mes(input_url  + "をダウンロードします。",1)

            thread1 = threading.Thread(target=main_sub, args=(enc_tag,tag, self,))
            thread1.start()
        else:
            self.mes(input_url + "をキューに入れます。",1)

            queue_lists.append(input_url)




    def error_mes(self, e):
        self.mes('=== エラー内容 ===',1)
        self.mes('type:' + str(type(e)),1)

        self.mes('error:' + str(e),1)
        exc_type, exc_obj, tb = sys.exc_info()
        lineno = tb.tb_lineno
        self.mes("エラー行番号" + str(lineno),1)

    def mes_func(self, event):
        dialog = wx.MessageDialog(None, 'flickrダウンローダGUI ver1.0.3', '', style=wx.OK)
        dialog.ShowModal()
        dialog.Destroy()



app = wx.App()
frame = GUI_class()

app.SetTopWindow(frame.frame)
app.MainLoop()



